> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pinecone.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Describe a model

> Get a description of a model hosted by Pinecone. 

You can use hosted models as an integrated part of Pinecone operations or for standalone embedding and reranking. For more details, see [Vector embedding](https://docs.pinecone.io/guides/index-data/indexing-overview#vector-embedding) and [Rerank results](https://docs.pinecone.io/guides/search/rerank-results).

<RequestExample>
  ```python Python theme={null}
  from pinecone import Pinecone

  pc = Pinecone(api_key="YOUR_API_KEY")

  model = pc.inference.get_model(model_name="llama-text-embed-v2")

  print(model)
  ```

  ```javascript JavaScript theme={null}
  const pc = new Pinecone({ apiKey: 'YOUR_API_KEY' });

  const model = await pc.inference.getModel('llama-text-embed-v2');

  console.log(model);
  ```

  ```java Java theme={null}
  import io.pinecone.clients.Inference;
  import io.pinecone.clients.Pinecone;
  import org.openapitools.inference.client.ApiException;
  import org.openapitools.inference.client.model.ModelInfo;

  public class DescribeModel {
      public static void main(String[] args) throws ApiException {
          Pinecone pinecone = new Pinecone.Builder("YOUR_API_KEY").build();

          Inference inference = pinecone.getInferenceClient();

          ModelInfo modelInfo = inference.describeModel("llama-text-embed-v2");
          System.out.println(modelInfo);
      }
  }
  ```

  ```go Go theme={null}
  package main

  import (
      "context"
      "encoding/json"
      "fmt"
      "log"

      "github.com/pinecone-io/go-pinecone/v4/pinecone"
  )

  func prettifyStruct(obj interface{}) string {
    	bytes, _ := json.MarshalIndent(obj, "", "  ")
      return string(bytes)
  }

  func main() {
      ctx := context.Background()

      pc, err := pinecone.NewClient(pinecone.NewClientParams{
          ApiKey: "YOUR_API_KEY",
      })
      if err != nil {
          log.Fatalf("Failed to create Client: %v", err)
      }

      model, err := pc.Inference.DescribeModel(ctx, "llama-text-embed-v2")
      if err != nil {
          log.Fatalf("Failed to get model: %v", err)
      }
      fmt.Printf(prettifyStruct(model))
  }
  ```

  ```csharp C# theme={null}
  using Pinecone;
  using Pinecone.Inference;

  var pinecone = new PineconeClient("YOUR_API_KEY");

  var model = await pinecone.Inference.Models.GetAsync("llama-text-embed-v2");

  Console.WriteLine(model);
  ```

  ```bash curl theme={null}
  PINECONE_API_KEY="YOUR_API_KEY"

  curl "https://api.pinecone.io/models/llama-text-embed-v2" \
      -H "Api-Key: $PINECONE_API_KEY" \
      -H "X-Pinecone-Api-Version: 2025-04"
  ```
</RequestExample>

<ResponseExample>
  ```python Python theme={null}
  {'default_dimension': 1024,
   'max_batch_size': 96,
   'max_sequence_length': 2048,
   'modality': 'text',
   'model': 'llama-text-embed-v2',
   'provider_name': 'NVIDIA',
   'short_description': 'A high performance dense embedding model optimized for '
                        'multilingual and cross-lingual text question-answering '
                        'retrieval with support for long documents (up to 2048 '
                        'tokens) and dynamic embedding size (Matryoshka '
                        'Embeddings).',
   'supported_dimensions': [384, 512, 768, 1024, 2048],
   'supported_metrics': [cosine, dotproduct],
   'supported_parameters': [{'allowed_values': ['query', 'passage'],
                             'parameter': 'input_type',
                             'required': True,
                             'type': 'one_of',
                             'value_type': 'string'},
                            {'allowed_values': ['END', 'NONE', 'START'],
                             'default': 'END',
                             'parameter': 'truncate',
                             'required': False,
                             'type': 'one_of',
                             'value_type': 'string'},
                            {'allowed_values': [384, 512, 768, 1024, 2048],
                             'default': 1024,
                             'parameter': 'dimension',
                             'required': False,
                             'type': 'one_of',
                             'value_type': 'integer'}],
   'type': 'embed',
   'vector_type': 'dense'}
  ```

  ```javascript JavaScript theme={null}
  {
    "model": "llama-text-embed-v2",
    "shortDescription": "A high performance dense embedding model optimized for multilingual and cross-lingual text question-answering retrieval with support for long documents (up to 2048 tokens) and dynamic embedding size (Matryoshka Embeddings).",
    "type": "embed",
    "vectorType": "dense",
    "defaultDimension": 1024,
    "modality": "text",
    "maxSequenceLength": 2048,
    "maxBatchSize": 96,
    "providerName": "NVIDIA",
    "supportedDimensions": [ 384, 512, 768, 1024, 2048 ],
    "supportedMetrics": [ "Cosine", "DotProduct" ],
    "supportedParameters": [
      {
        parameter: 'input_type',
        type: 'one_of',
        valueType: 'string',
        required: true,
        allowedValues: [Array],
        min: undefined,
        max: undefined,
        _default: undefined
      },
      {
        parameter: 'truncate',
        type: 'one_of',
        valueType: 'string',
        required: false,
        allowedValues: [Array],
        min: undefined,
        max: undefined,
        _default: 'END'
      },
      {
        parameter: 'dimension',
        type: 'one_of',
        valueType: 'integer',
        required: false,
        allowedValues: [Array],
        min: undefined,
        max: undefined,
        _default: 1024
      }
    ]
  }
  ```

  ```java Java theme={null}
  class ModelInfo {
      model: llama-text-embed-v2
      shortDescription: A high performance dense embedding model optimized for multilingual and cross-lingual text question-answering retrieval with support for long documents (up to 2048 tokens) and dynamic embedding size (Matryoshka Embeddings).
      type: embed
      vectorType: dense
      defaultDimension: 1024
      modality: text
      maxSequenceLength: 2048
      maxBatchSize: 96
      providerName: NVIDIA
      supportedDimensions: [384, 512, 768, 1024, 2048]
      supportedMetrics: [cosine, dotproduct]
      supportedParameters: [class ModelInfoSupportedParameter {
          parameter: input_type
          type: one_of
          valueType: string
          required: true
          allowedValues: [class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: query
              isNullable: false
              schemaType: anyOf
          }, class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: passage
              isNullable: false
              schemaType: anyOf
          }]
          min: null
          max: null
          _default: null
          additionalProperties: null
      }, class ModelInfoSupportedParameter {
          parameter: truncate
          type: one_of
          valueType: string
          required: false
          allowedValues: [class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: END
              isNullable: false
              schemaType: anyOf
          }, class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: NONE
              isNullable: false
              schemaType: anyOf
          }, class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: START
              isNullable: false
              schemaType: anyOf
          }]
          min: null
          max: null
          _default: class class org.openapitools.inference.client.model.ModelInfoSupportedParameterDefault {
              instance: END
              isNullable: false
              schemaType: anyOf
          }
          additionalProperties: null
      }, class ModelInfoSupportedParameter {
          parameter: dimension
          type: one_of
          valueType: integer
          required: false
          allowedValues: [class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: 384
              isNullable: false
              schemaType: anyOf
          }, class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: 512
              isNullable: false
              schemaType: anyOf
          }, class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: 768
              isNullable: false
              schemaType: anyOf
          }, class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: 1024
              isNullable: false
              schemaType: anyOf
          }, class class org.openapitools.inference.client.model.ModelInfoSupportedParameterAllowedValuesInner {
              instance: 2048
              isNullable: false
              schemaType: anyOf
          }]
          min: null
          max: null
          _default: class class org.openapitools.inference.client.model.ModelInfoSupportedParameterDefault {
              instance: 1024
              isNullable: false
              schemaType: anyOf
          }
          additionalProperties: null
      }]
      additionalProperties: null
  }
  ```

  ```go Go theme={null}
  {
    "default_dimension": 1024,
    "max_batch_size": 96,
    "max_sequence_length": 2048,
    "modality": "text",
    "model": "llama-text-embed-v2",
    "provider_name": "NVIDIA",
    "short_description": "A high performance dense embedding model optimized for multilingual and cross-lingual text question-answering retrieval with support for long documents (up to 2048 tokens) and dynamic embedding size (Matryoshka Embeddings).",
    "supported_dimensions": [
      384,
      512,
      768,
      1024,
      2048
    ],
    "supported_metrics": [
      "cosine",
      "dotproduct"
    ],
    "supported_parameters": [
      {
        "allowed_values": [
          {
            "StringValue": "query",
            "IntValue": null,
            "FloatValue": null,
            "BoolValue": null
          },
          {
            "StringValue": "passage",
            "IntValue": null,
            "FloatValue": null,
            "BoolValue": null
          }
        ],
        "parameter": "input_type",
        "required": true,
        "type": "one_of",
        "value_type": "string"
      },
      {
        "allowed_values": [
          {
            "StringValue": "END",
            "IntValue": null,
            "FloatValue": null,
            "BoolValue": null
          },
          {
            "StringValue": "NONE",
            "IntValue": null,
            "FloatValue": null,
            "BoolValue": null
          },
          {
            "StringValue": "START",
            "IntValue": null,
            "FloatValue": null,
            "BoolValue": null
          }
        ],
        "default": {
          "StringValue": "END",
          "IntValue": null,
          "FloatValue": null,
          "BoolValue": null
        },
        "parameter": "truncate",
        "required": false,
        "type": "one_of",
        "value_type": "string"
      },
      {
        "allowed_values": [
          {
            "StringValue": null,
            "IntValue": 384,
            "FloatValue": null,
            "BoolValue": null
          },
          {
            "StringValue": null,
            "IntValue": 512,
            "FloatValue": null,
            "BoolValue": null
          },
          {
            "StringValue": null,
            "IntValue": 768,
            "FloatValue": null,
            "BoolValue": null
          },
          {
            "StringValue": null,
            "IntValue": 1024,
            "FloatValue": null,
            "BoolValue": null
          },
          {
            "StringValue": null,
            "IntValue": 2048,
            "FloatValue": null,
            "BoolValue": null
          }
        ],
        "default": {
          "StringValue": null,
          "IntValue": 1024,
          "FloatValue": null,
          "BoolValue": null
        },
        "parameter": "dimension",
        "required": false,
        "type": "one_of",
        "value_type": "integer"
      }
    ],
    "type": "embed",
    "vector_type": "dense"
  }
  ```

  ```csharp C# theme={null}
  {
    "model": "llama-text-embed-v2",
    "short_description": "A high performance dense embedding model optimized for multilingual and cross-lingual text question-answering retrieval with support for long documents (up to 2048 tokens) and dynamic embedding size (Matryoshka Embeddings).",
    "type": "embed",
    "vector_type": "dense",
    "default_dimension": 1024,
    "modality": "text",
    "max_sequence_length": 2048,
    "max_batch_size": 96,
    "provider_name": "NVIDIA",
    "supported_dimensions": [
      384,
      512,
      768,
      1024,
      2048
    ],
    "supported_metrics": [
      "cosine",
      "cosine"
    ],
    "supported_parameters": [
      {
        "parameter": "input_type",
        "type": "one_of",
        "value_type": "string",
        "required": true,
        "allowed_values": [
          "query",
          "passage"
        ]
      },
      {
        "parameter": "truncate",
        "type": "one_of",
        "value_type": "string",
        "required": false,
        "allowed_values": [
          "END",
          "NONE",
          "START"
        ],
        "default": "END"
      },
      {
        "parameter": "dimension",
        "type": "one_of",
        "value_type": "integer",
        "required": false,
        "allowed_values": [
          384,
          512,
          768,
          1024,
          2048
        ],
        "default": 1024
      }
    ]
  }
  ```

  ```json curl theme={null}
  {
    "model": "llama-text-embed-v2",
    "short_description": "A high performance dense embedding model optimized for multilingual and cross-lingual text question-answering retrieval with support for long documents (up to 2048 tokens) and dynamic embedding size (Matryoshka Embeddings).",
    "type": "embed",
    "vector_type": "dense",
    "default_dimension": 1024,
    "modality": "text",
    "max_sequence_length": 2048,
    "max_batch_size": 96,
    "provider_name": "NVIDIA",
    "supported_metrics": [
      "Cosine",
      "DotProduct"
    ],
    "supported_dimensions": [
      384,
      512,
      768,
      1024,
      2048
    ],
    "supported_parameters": [
      {
        "parameter": "input_type",
        "required": true,
        "type": "one_of",
        "value_type": "string",
        "allowed_values": [
          "query",
          "passage"
        ]
      },
      {
        "parameter": "truncate",
        "required": false,
        "default": "END",
        "type": "one_of",
        "value_type": "string",
        "allowed_values": [
          "END",
          "NONE",
          "START"
        ]
      },
      {
        "parameter": "dimension",
        "required": false,
        "default": 1024,
        "type": "one_of",
        "value_type": "integer",
        "allowed_values": [
          384,
          512,
          768,
          1024,
          2048
        ]
      }
    ]
  }
  ```
</ResponseExample>


## OpenAPI

````yaml https://raw.githubusercontent.com/pinecone-io/pinecone-api/refs/heads/main/2025-04/inference_2025-04.oas.yaml get /models/{model_name}
openapi: 3.0.3
info:
  title: Pinecone Inference API
  description: >-
    Pinecone is a vector database that makes it easy to search and retrieve
    billions of high-dimensional vectors.
  contact:
    name: Pinecone Support
    url: https://support.pinecone.io
    email: support@pinecone.io
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0
  version: 2025-04
servers:
  - url: https://api.pinecone.io
    description: Production API endpoints
security:
  - ApiKeyAuth: []
tags:
  - name: Inference
    description: Model inference
externalDocs:
  description: More Pinecone.io API docs
  url: https://docs.pinecone.io/introduction
paths:
  /models/{model_name}:
    get:
      tags:
        - Inference
      summary: Describe a model
      description: >-
        Get a description of a model hosted by Pinecone. 


        You can use hosted models as an integrated part of Pinecone operations
        or for standalone embedding and reranking. For more details, see [Vector
        embedding](https://docs.pinecone.io/guides/index-data/indexing-overview#vector-embedding)
        and [Rerank
        results](https://docs.pinecone.io/guides/search/rerank-results).
      operationId: get_model
      parameters:
        - in: path
          name: model_name
          description: The name of the model to look up.
          required: true
          schema:
            type: string
          example: multilingual-e5-large
          style: simple
      responses:
        '200':
          description: The model details.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ModelInfo'
              examples:
                embedding-model:
                  summary: An embedding model.
                  value:
                    max_batch_size: 96
                    default_dimension: 256
                    modality: text
                    model: example-embedding-model
                    max_sequence_length: 512
                    provider_name: Embedding Model Provider
                    supported_dimensions:
                      - 256
                      - 512
                    short_description: An example embedding model.
                    supported_metrics:
                      - cosine
                      - euclidean
                    supported_parameters:
                      - allowed_values:
                          - value1
                          - value2
                        parameter: example_required_param
                        required: true
                        type: one_of
                        value_type: string
                      - allowed_values:
                          - value1
                          - value2
                        default: value1
                        parameter: example_param_with_default
                        required: false
                        type: one_of
                        value_type: string
                      - default: 5
                        max: 10
                        min: 0
                        parameter: example_numeric_range
                        required: false
                        type: numeric_range
                        value_type: integer
                    type: embed
                    vector_type: dense
                rerank-model:
                  summary: A reranking model.
                  value:
                    max_batch_size: 100
                    modality: text
                    model: example-reranking-model
                    max_sequence_length: 1024
                    provider_name: Reranking Model Provider
                    short_description: An example reranking model.
                    supported_parameters:
                      - default: true
                        parameter: example_any_value
                        required: false
                        type: any
                        value_type: boolean
                    type: rerank
        '401':
          description: 'Unauthorized. Possible causes: Invalid API key.'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              examples:
                unauthorized:
                  summary: Unauthorized
                  value:
                    error:
                      code: UNAUTHENTICATED
                      message: Invalid API key.
                    status: 401
        '404':
          description: Model not found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              examples:
                model-not-found:
                  summary: Model not found
                  value:
                    error:
                      code: NOT_FOUND
                      message: Model example-model not found.
                    status: 404
        '500':
          description: Internal server error.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              examples:
                internal-server-error:
                  summary: Internal server error
                  value:
                    error:
                      code: UNKNOWN
                      message: Internal server error
                    status: 500
components:
  schemas:
    ModelInfo:
      description: >-
        Represents the model configuration including model type, supported
        parameters, and other model details.
      type: object
      properties:
        model:
          example: multilingual-e5-large
          description: The name of the model.
          type: string
        short_description:
          example: multilingual-e5-large
          description: A summary of the model.
          type: string
        type:
          example: embed
          description: The type of model (e.g. 'embed' or 'rerank').
          type: string
        vector_type:
          description: Whether the embedding model produces 'dense' or 'sparse' embeddings.
          type: string
        default_dimension:
          example: 1024
          description: >-
            The default embedding model dimension (applies to dense embedding
            models only).
          type: integer
          format: int32
          minimum: 1
          maximum: 20000
        modality:
          example: text
          description: The modality of the model (e.g. 'text').
          type: string
        max_sequence_length:
          example: 512
          description: The maximum tokens per sequence supported by the model.
          type: integer
          format: int32
          minimum: 1
        max_batch_size:
          example: 96
          description: The maximum batch size (number of sequences) supported by the model.
          type: integer
          format: int32
          minimum: 1
        provider_name:
          example: NVIDIA
          description: The name of the provider of the model.
          type: string
        supported_dimensions:
          description: >-
            The list of supported dimensions for the model (applies to dense
            embedding models only).
          type: array
          items:
            example: 1024
            type: integer
            format: int32
            minimum: 1
            maximum: 20000
        supported_metrics:
          $ref: '#/components/schemas/ModelInfoSupportedMetrics'
        supported_parameters:
          type: array
          items:
            $ref: '#/components/schemas/ModelInfoSupportedParameter'
      required:
        - model
        - short_description
        - type
        - supported_parameters
    ErrorResponse:
      example:
        error:
          code: QUOTA_EXCEEDED
          message: >-
            The index exceeds the project quota of 5 pods by 2 pods. Upgrade
            your account or change the project settings to increase the quota.
        status: 429
      description: The response shape used for all error responses.
      type: object
      properties:
        status:
          example: 500
          description: The HTTP status code of the error.
          type: integer
        error:
          example:
            code: INVALID_ARGUMENT
            message: >-
              Index name must contain only lowercase alphanumeric characters or
              hyphens, and must not begin or end with a hyphen.
          description: Detailed information about the error that occurred.
          type: object
          properties:
            code:
              type: string
              enum:
                - OK
                - UNKNOWN
                - INVALID_ARGUMENT
                - DEADLINE_EXCEEDED
                - QUOTA_EXCEEDED
                - NOT_FOUND
                - ALREADY_EXISTS
                - PERMISSION_DENIED
                - UNAUTHENTICATED
                - RESOURCE_EXHAUSTED
                - FAILED_PRECONDITION
                - ABORTED
                - OUT_OF_RANGE
                - UNIMPLEMENTED
                - INTERNAL
                - UNAVAILABLE
                - DATA_LOSS
                - FORBIDDEN
            message:
              example: >-
                Index name must contain only lowercase alphanumeric characters
                or hyphens, and must not begin or end with a hyphen.
              type: string
            details:
              description: >-
                Additional information about the error. This field is not
                guaranteed to be present.
              type: object
          required:
            - code
            - message
      required:
        - status
        - error
    ModelInfoSupportedMetrics:
      description: The distance metrics supported by the model for similarity search.
      type: array
      items:
        $ref: '#/components/schemas/ModelInfoMetric'
    ModelInfoSupportedParameter:
      description: >-
        Describes a parameter supported by the model, including parameter value
        constraints.
      type: object
      properties:
        parameter:
          example: input_type
          description: The name of the parameter.
          type: string
        type:
          example: one_of
          description: >-
            The parameter type e.g. 'one_of', 'numeric_range', or 'any'.


            If the type is 'one_of', then 'allowed_values' will be set, and the
            value specified must be one of the allowed values. 'one_of' is only
            compatible with value_type 'string' or 'integer'.


            If 'numeric_range', then 'min' and 'max' will be set, then the value
            specified must adhere to the value_type and must fall within the
            `[min, max]` range (inclusive).


            If 'any' then any value is allowed, as long as it adheres to the
            value_type.
          type: string
        value_type:
          example: string
          description: >-
            The type of value the parameter accepts, e.g. 'string', 'integer',
            'float', or 'boolean'.
          type: string
        required:
          example: true
          description: Whether the parameter is required (true) or optional (false).
          type: boolean
        allowed_values:
          description: The allowed parameter values when the type is 'one_of'.
          type: array
          items:
            anyOf:
              - type: string
              - type: integer
        min:
          example: 1
          description: >-
            The minimum allowed value (inclusive) when the type is
            'numeric_range'.
          type: number
        max:
          example: 1
          description: >-
            The maximum allowed value (inclusive) when the type is
            'numeric_range'.
          type: number
        default:
          example: END
          description: The default value for the parameter when a parameter is optional.
          anyOf:
            - type: string
            - type: integer
              format: int32
            - type: number
              format: float
            - type: boolean
      required:
        - parameter
        - type
        - value_type
        - required
    ModelInfoMetric:
      description: >-
        A distance metric that the embedding model supports for similarity
        searches.
      type: string
      enum:
        - cosine
        - euclidean
        - dotproduct
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: Api-Key
      description: >-
        An API Key is required to call Pinecone APIs. Get yours from the
        [console](https://app.pinecone.io/).

````